//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property description "McGinley dynamic average"
#property description "made for metatrader by mladen"
#property description "for more visit www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_width1     2
#property indicator_width2     2
#property indicator_minimum    0
#property indicator_maximum    1

extern int                McgPeriod   = 21;
extern ENUM_APPLIED_PRICE McgPrice    = PRICE_CLOSE;
extern ENUM_MA_METHOD     McgMaMethod = MODE_EMA;

double mcg[];
double histou[];
double histod[];
double slope[];
double ma[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,histou); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histod); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,mcg);
   SetIndexBuffer(3,slope);
   SetIndexBuffer(4,ma);
   
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--; 
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      ma[i] = iMA(NULL,0,McgPeriod,0,McgMaMethod,McgPrice,i);
      if (i<Bars-1 && ma[i+1]!=0)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,McgPrice,i);
         mcg[i]    = ma[i+1]+(price-ma[i+1])/(price/ma[i+1]*125.0);
         histou[i] = EMPTY_VALUE;
         histod[i] = EMPTY_VALUE;
         slope[i]  = slope[i+1];
            if (mcg[i]>mcg[i+1]) slope[i] =  1;
            if (mcg[i]<mcg[i+1]) slope[i] = -1;
            if (slope[i]== 1) histou[i] =1;
            if (slope[i]==-1) histod[i] =1;
      }               
   }
   return(0); 
}